#!/bin/sh
PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin
#RC_CONF=/var/run/rc.conf
#SCRIPT=$0
echo "" >/dev/null

# include the enviro's

#. $RC_CONF

STATUS_FILE="/var/update_status"
BUSYBOX="/var/busybox"

cp /bin/busybox $BUSYBOX
cp /bin/eraseall /var/eraseall

UPGRADE_PARTITION=`fw_printenv img_upgrade|awk -F"=" '{print $2}'`
ACTIVE_PARTITION=`fw_printenv img_active|awk -F"=" '{print $2}'`
BOOT_PARTITION=`fw_printenv img_boot|awk -F"=" '{print $2}'`
DUAL_IMG=`fw_printenv model_tel|awk -F"=" '{print $2}'`

cd /tmp

touch fw_test
fw_setenv img_boot $UPGRADE_PARTITION
##### kill process #######
#/bin/killall crond

echo "set img_boot" >> fw_test
if [ $UPGRADE_PARTITION = "0" ]; then
CHAR_K="/dev/mtdchar1"
BLOCK_K="/dev/mtdblock1"
CHAR_R="/dev/mtdchar3"
BLOCK_R="/dev/mtdblock3"
CHAR_C="/dev/mtdchar5"
BLOCK_C="/dev/mtdblock5"
else
CHAR_K="/dev/mtdchar2"
BLOCK_K="/dev/mtdblock2"
CHAR_R="/dev/mtdchar4"
BLOCK_R="/dev/mtdblock4"
CHAR_C="/dev/mtdchar6"
BLOCK_C="/dev/mtdblock6"
fi 


if [ $ACTIVE_PARTITION = "0" ]; then
BACKUP_C="/dev/mtdblock6"
else
BACKUP_C="/dev/mtdblock5"
fi

echo "set partition val" >> fw_test

if [ "$ACTIVE_PARTITION" != "$UPGRADE_PARTITION" ]; then
	CKSUM_DIR="/mnt"	
	mount -t jffs2 $BLOCK_C $CKSUM_DIR
else
	CKSUM_DIR="/empfs"
fi
echo "CKSUM_DIR=$CKSUM_DIR"

[ -e $CKSUM_DIR/config ] && cp $CKSUM_DIR/config /tmp/config
[ -e $CKSUM_DIR/etc/init.d/ntp.conf ] && cp $CKSUM_DIR/etc/init.d/ntp.conf /tmp/ntp.conf

##### start update cimage ###
	if [ -f cimage.jffs2 ]; then
		echo "set config" >> fw_test
		umount $CKSUM_DIR
		/var/eraseall $CHAR_C
		$BUSYBOX cat /tmp/cimage.jffs2 > $CHAR_C
		mount -t jffs2 $BLOCK_C $CKSUM_DIR
		[ -e /tmp/config ] && cp /tmp/config $CKSUM_DIR/.
		[ -e /tmp/ntp.conf ] && cp /tmp/ntp.conf $CKSUM_DIR/etc/init.d/.
		echo "upgrade cimage"
		$BUSYBOX echo "Config updates success!" >> $STATUS_FILE
		[ "$ACTIVE_PARTITION" != "$UPGRADE_PARTITION" ] &&  umount $CKSUM_DIR

	fi

##### start update kimage ###

	if [ -f vmlinux_zip.bix ]; then
		echo "upgrade cimage" >> fw_test
		/var/eraseall $CHAR_K
		echo "upgrade kimage"
		$BUSYBOX cp /tmp/vmlinux_zip.bix $CHAR_K
	fi

##### start update rimage ###
	if [ -f cramfs.bin ]; then
		echo "upgrade kimage" >> fw_test
		/var/eraseall $CHAR_R
		echo "upgrade rimage"
		$BUSYBOX cp /tmp/cramfs.bin $CHAR_R
	fi

	if [ -f squashfs.bin ]; then
		echo "upgrade rimage" >> fw_test
		/var/eraseall $CHAR_R
		echo "upgrade rimage"
		$BUSYBOX cp /tmp/squashfs.bin $CHAR_R
	fi

	if [ -f bimage.bin ]; then
		cat /proc/mtd|grep mtd7
		if [ $? = 1 ]; then
			echo "the kernel is too old, please upgrade kernel first"
                        exit 0
                else
			echo "upgrade bootloader" >> fw_test
                        # remove version in boot enviroment
                        fw_setenv ver
			/var/eraseall /dev/mtdchar7
			echo "upgrade bootloader"
			$BUSYBOX cp /tmp/bimage.bin /dev/mtdblock7
                fi
	fi


if [ -f vmlinux_zip.bix ] || [ -f cramfs.bin ] || [ -f squashfs.bin ]; then
	if [ "$ACTIVE_PARTITION" != "$UPGRADE_PARTITION" ]; then
		mount -t jffs2 $BLOCK_C /mnt
		cp /empfs/config /mnt/config
		cp /tmp/checksum /mnt/etc/checksum
		if [ "$DUAL_IMG" != "1" ]; then
			cp /tmp/checksum /empfs/etc/.
		fi
		umount /mnt
		echo "backup config and cheksum"
	else
		if [ "$DUAL_IMG" != "1" ]; then
			echo "not implement yet"
		fi

	fi
        if [ $UPGRADE_PARTITION = "0" ]; then
		fw_setenv img_valid_0 0
        else
		fw_setenv img_valid_1 0
        fi
	echo "set img_valid" >> fw_test

	fw_setenv bootargs1 root=/dev/mtdblock3 ro rootfstype=squashfs,cramfs console=ttyS0,9600 mem=64M quiet
	fw_setenv bootargs2 root=/dev/mtdblock4 ro rootfstype=squashfs,cramfs console=ttyS0,9600 mem=64M quiet
#	$BUSYBOX sync
#	if [ -f /bin/gpio_util ]; then
#		gpio_util set e 7 0
#	fi
#	$BUSYBOX kill -TERM 1
else
	# don't change boot partition if only bootloader need to be upgraded 
	fw_setenv img_boot $ACTIVE_PARTITION
        
fi
	$BUSYBOX sync
	if [ -f /bin/gpio_util ]; then
		gpio_util set e 7 0
	fi
	$BUSYBOX kill -TERM 1

